﻿Imports Wiker.WIDatabase
Imports System.Text
Module Module1

    Sub Main()
    Dim WIDB As WIDatabase
        Dim ColumnDataStr As String
        Dim StrB As StringBuilder
        Dim DBInfo As CDatabaseInfo

        ColumnDataStr = ""

        ' Create DatabaseInfo object with login info  

        DBInfo = New CDatabaseInfo()
        DBInfo.DatabaseType = eDatabaseType.SQLite
        DBInfo.Location = "\WIDatabase\Samples"
        DBInfo.DBName = "SQLite.db3"
        DBInfo.Password = ""
        DBInfo.Port = 0
        DBInfo.Username = ""

        ' Create WIDatabase object 

        WIDB = New WIDatabase(DBInfo)

        ' Calling Select.Clear() ensures we starting with a new select statement. 

        WIDB.[Search].Clear()

        ' The Column Class is used to choose columns to be returned 

        WIDB.[Search].Column("tblPerson", "Name", "PersonName")
        WIDB.[Search].Column("tblCompany", "Name", "CompanyName")
        WIDB.[Search].Column("tblAddress", "Address1", "PersonAddress1")
        WIDB.[Search].Column("tblAddress", "Address2", "PersonAddress2")
        WIDB.[Search].Column("tblAddress", "City", "PersonCity")
        WIDB.[Search].Column("tblAddress", "State", "PersonState")
        WIDB.[Search].Column("tblAddress", "ZipCode", "PersonZipCode")

        ' Select.Table: The 'Main' table from which the data will originate */
        WIDB.[Search].Table("tblPerson")

        ' Select.Join: Used to 'connect' related tables. */
        WIDB.[Search].Join("tblCompany", "CompanyID", eOperator.Equal, "tblPerson", "CompanyID", eJoinType.Normal)
        WIDB.[Search].Join("tblAddress", "AddressID", eOperator.Equal, "tblPerson", "AddressID", eJoinType.Normal)

        ' Select.Execute() prepares the statement to be sent to the Database 
        WIDB.[Search].Execute()

        Console.WriteLine("| PersonName | CompanyName | PersonAddress1 | PersonAddress2 | PersonCity | PersonState | PersonZipCode |")

        ' Select.Read() reads the next row from the returned data 

        While WIDB.[Search].Read()
            StrB = New StringBuilder()

            ' Select.Get obtains the value of the named column via an out parameter 

            WIDB.[Search].Get("PersonName", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("CompanyName", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("PersonAddress1", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("PersonAddress2", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("PersonCity", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("PersonState", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("PersonZipCode", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            Console.WriteLine(StrB.ToString())
        End While

        ' Good practice is to close the DB when finished 

        WIDB.Close()

    End Sub

End Module
